import java.util.Scanner;

public class KnapsackGA {
  public static final int KNAP_MAX = 6;		// ibvTbN̑Ϗd
  public static final int ITEM_NUM = 5;		// i̎

  public static final int IND_NUM = 8;		// ̂̐
  public static final double MUTATE_RATE = 0.1;	// ˑRψقmi10j

  public static char[] itemName = { 'A', 'B', 'C', 'D', 'E' };	// i̖
  public static int[] itemWeight = { 1, 2, 3, 4, 5 };		// ȉd
  public static int[] itemValue = { 100, 300, 350, 500, 650 };	// ỉl

  public static int indGeneration;				// ̂̐
  public static int[][] indGene = new int[IND_NUM][ITEM_NUM];	// ̂̈`q
  public static int[] indWeight = new int[IND_NUM];		// ̂̏d
  public static int[] indValue = new int[IND_NUM];		// ̂̉l
  public static int[] indFitness = new int[IND_NUM];		// ̂̓Kx

  // ̂_ɐ郁\bh
  public static void createIndividual() {
    int ind, item;	// [vJE^

    // 01_Ɋi[
    for (ind = 0; ind < IND_NUM; ind++) {
      for (item = 0; item < ITEM_NUM; item++) {
        indGene[ind][item] = Math.random() > 0.5 ? 0 : 1;
      }
    }
  }

  // ̂̏dʁAlAKxvZ郁\bh
  public static void calcIndividual() {
    int ind, item;	// [vJE^

    for (ind = 0; ind < IND_NUM; ind++) {
      // dʂƉlvZ
      indWeight[ind] = 0;
      indValue[ind] = 0;
      for (item = 0; item < ITEM_NUM; item++) {
        if (indGene[ind][item] == 1) {
          indWeight[ind] += itemWeight[item];
          indValue[ind] += itemValue[item];
        }
      }

      // KxvZ
      if (indWeight[ind] <= KNAP_MAX) {
        // ϏdʈȉȂAl̂܂ܓKxƂ
        indFitness[ind] = indValue[ind];
      }
      else {
        // Ϗdʂ𒴂ĂȂAKx0Ƃ
        indFitness[ind] = 0;
      }
    }
  }

  // ̂̏\郁\bh
  public static void showIndividual() {
    int ind, item;	// [vJE^

    // \
    System.out.printf("\n%dい\n", indGeneration);

    // `qAdʁAlAKx\
    System.out.printf("`q\t\td\tl\tKx\n");
    for (ind = 0; ind < IND_NUM; ind++) {
      for (item = 0; item < ITEM_NUM; item++) {
        System.out.printf("[%d]", indGene[ind][item]);
      }
      System.out.printf("\t%2dkg\t%4d~\t%4d\n", indWeight[ind], indValue[ind], indFitness[ind]);
    }
    System.out.printf("\n");
  }

  // ̂Kx̑傫Ƀ\[g郁\bh
  public static void sortIndividual() {
    int pos;	// }vf
    int ins;	// }ʒu
    int item;	// [vJE^
    int tmp;	// ꎞIɒl𓦂ϐ

    // }@Ń\[g
    for (pos = 1; pos < IND_NUM; pos++) {
      ins = pos;
      while (ins >= 1 && indFitness[ins - 1] < indFitness[ins]) {
        for (item = 0; item < ITEM_NUM; item++) {
          tmp = indGene[ins - 1][item];
          indGene[ins - 1][item] = indGene[ins][item];
          indGene[ins][item] = tmp;
        }

        tmp = indWeight[ins - 1];
        indWeight[ins - 1] = indWeight[ins];
        indWeight[ins] = tmp;

        tmp =  indValue[ins - 1];
        indValue[ins - 1] = indValue[ins];
        indValue[ins] = tmp;

        tmp = indFitness[ins - 1];
        indFitness[ins - 1] = indFitness[ins];
        indFitness[ins] = tmp;

        ins--;
      }
    }
  }

  // 郁\bh
  public static void selectIndividual() {
    int ind, item;	// [vJE^

    // Kx̏5050ɃRs[i50𓑑j
    for (ind = 0; ind < IND_NUM / 2; ind++) {
      for (item = 0; item < ITEM_NUM; item++) {
        indGene[ind + IND_NUM / 2][item] = indGene[ind][item];
      }
    }
    System.out.printf("50𓑑܂B\n");
  }

  // 郁\bh
  public static void crossoverIndividual() {
    int ind, item;	// [vJE^
    int crossoverPoint;	// ʒu
    int tmp;		// ꎞIɒl𓦂ϐ

    // 50ɃRs[̂ΏۂƂ
    for (ind = IND_NUM / 2; ind < (IND_NUM - 1); ind += 2) {
      // ʒu_Ɍ߂
      crossoverPoint = (int)(Math.random() * 10000) % (ITEM_NUM - 1) + 1;
      for (item = crossoverPoint; item < ITEM_NUM; item++) {
        // ׂ̌̂ƌ
        tmp = indGene[ind][item];
        indGene[ind][item] = indGene[ind + 1][item];
        indGene[ind + 1][item] = tmp;
      }
      System.out.printf("%dƌ%d%d̈ʒuŌ܂B\n", ind, ind + 1, crossoverPoint);
    }
  }

  // ˑRψق郁\bh
  public static void mutateIndividual() {
    int ind, item;	// [vJE^

    // 50ɃRs[̂ΏۂƂ
    for (ind = IND_NUM / 2; ind < IND_NUM; ind++) {
      for (item = 0; item < ITEM_NUM; item++) {
        // 炩ߌ߂ꂽmœˑRψق
        if (Math.random() <= MUTATE_RATE) {
          // ]
          indGene[ind][item] ^= 1;
          System.out.printf("%d%d̈ʒuœˑRψق܂B\n", ind, item);
        }
      }
    }
  }

  // vO̎sJnʒuƂȂmain\bh
  public static void main(String[] args) {
    int genMax;	// ő̐
    int item;	// [vJE^

    // ő̐L[͂
    Scanner scn = new Scanner(System.in);
    System.out.printf("ő̐ = ");
    genMax = scn.nextInt();

    // 1̌̂𐶐
    indGeneration = 1;
    createIndividual();

    // KxvZ
    calcIndividual();

    // Kx傫Ƀ\[g
    sortIndividual();

    // ̂\
    showIndividual();

    // 1ジi
    indGeneration++;
    while (indGeneration <= genMax) {
      // Kx傫Ƀ\[g
      sortIndividual();

      // 
      selectIndividual();

      // 
      crossoverIndividual();

      // ˑRψق
      mutateIndividual();

      // KxvZ
      calcIndividual();

      // Kx傫Ƀ\[g
      sortIndividual();

      // ̂\
      showIndividual();

      // i߂
      indGeneration++;
    }

    // łKx̍̂Ƃĕ\
    System.out.printf("ibvTbNɓĂi\遄\n");
    for (item = 0; item < ITEM_NUM; item++) {
      if (indGene[0][item] == 1) {
        System.out.printf("%c, %dkg, %d~\n", itemName[item], itemWeight[item], itemValue[item]);
      }
    }
    System.out.printf("\n\遄\n");
    System.out.printf("dʂ̍vl = %dkg\n", indWeight[0]);
    System.out.printf("l̍ől = %d~\n", indValue[0]);
  }
}
